/*
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Bitflux GmbH                                      |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// | http://www.apache.org/licenses/LICENSE-2.0                           |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or      |
// | implied. See the License for the specific language governing         |
// | permissions and limitations under the License.                       |
// +----------------------------------------------------------------------+
// | Author: Bitflux GmbH <devel@bitflux.ch>                              |
// |      |
// +----------------------------------------------------------------------+
*/

var livesearch_settings = new Array();
//general settings:
livesearch_settings['general'] = new Object();
livesearch_settings['general']['liveSearchRoot'] = "js/";

//settings for tag-search: (id of input-field has to be 'tag')
livesearch_settings['tag'] = new Object();
livesearch_settings['tag']['liveSearchParams'] = "";
livesearch_settings['tag']['css_prefix'] = "tagsearch_";

//settings for babe-search: (id of input-field has to be 'babe')
livesearch_settings['babe'] = new Object();
livesearch_settings['babe']['liveSearchParams'] = "";
livesearch_settings['babe']['css_prefix'] = "babesearch_";
livesearch_settings['babe']['max_results'] = 7;

// url to image-dir:
var image_path = "http://beta.skins.be/media/img/";

var no_other_resolution = new Array();
no_other_resolution['en'] = "No other resolutions available";
no_other_resolution['de'] = "Keine anderen Aufl&ouml;sungen verf&uuml;gbar";


var liveSearchReq = false;
var t = null;
var liveSearchLast = "";
var liveSearchRoot = livesearch_settings['general']['liveSearchRoot'];
var isIE = false;

// on !IE we only have to initialize it once
if(window.XMLHttpRequest)
{
	liveSearchReq = new XMLHttpRequest();
}

// initialize event-listener for all configured and existing fields
function liveSearchInit()
{
	for(var key in livesearch_settings)
	{
		if(document.getElementById(key))
		{
			liveSearchInitField(key);
		}
	}
}

// assign down-, up- and esc-key to a input field
function liveSearchInitField(fieldid)
{
		isIE = true;
	document.getElementById(fieldid).setAttribute("autocomplete","off");
}

function liveSearchKeyPress(event)
{
	fieldid = this.getAttribute("id", false);
	if(event.keyCode == 40) //ARROW-KEY DOWN
	{
		highlight = document.getElementById("LSHighlight");
		if(!highlight)
		{
			highlight = document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSShadow").firstChild.firstChild;
		}
		else
		{
			highlight.removeAttribute("id");
			highlight = highlight.nextSibling;
		}
		if(highlight)
		{
			highlight.setAttribute("id","LSHighlight");
		}
		if(!isIE)
		{
			event.preventDefault();
		}
	}
	else if(event.keyCode == 38 ) //ARROW-KEY UP
	{
		highlight = document.getElementById("LSHighlight");
		if(!highlight)
		{
			highlight = document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSShadow").firstChild.lastChild;
		}
		else
		{
			highlight.removeAttribute("id");
			highlight = highlight.previousSibling;
		}
		if(highlight)
		{
			highlight.setAttribute("id","LSHighlight");
		}
		if(!isIE)
		{
			event.preventDefault();
		}
	}
	else if(event.keyCode == 27) //ESC-KEY
	{
		highlight = document.getElementById("LSHighlight");
		if(highlight)
		{
			highlight.removeAttribute("id");
		}
		document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSResult").style.display = "none";
	}
}

// close the result div
function liveSearchHideDelayed()
{
	fieldid = this.getAttribute("id", false);
	window.setTimeout("liveSearchHide('" + fieldid + "')",400);
}

function liveSearchHide(fieldid)
{
	document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSResult").style.display = "none";
	var highlight = document.getElementById("LSHighlight");
	if (highlight)
	{
		highlight.removeAttribute("id");
	}
	liveSearchLast = '';
}

// start a search
function liveSearchStart(fieldid)
{
	if(t)
	{
		window.clearTimeout(t);
	}
	switch(fieldid)
	{
		//start a tag-search:
		case "tag":
			t = window.setTimeout("liveSearchTagSearch('" + fieldid + "')",200);
			break;

		//start a babe-search:
		case "babe":
			t = window.setTimeout("liveSearchBabeSearch('" + fieldid + "')",200);
			break;
	}
}

//tag-search:
function liveSearchTagSearch(fieldid)
{
	var searchvalue = document.getElementById(fieldid).value;

	if(searchvalue.indexOf(',') > 0)
	{
		searchvalue = searchvalue.substr(searchvalue.lastIndexOf(',') + 1);
		searchvalue = trim(searchvalue);
	}

	if(typeof liveSearchRoot == "undefined")
	{
		liveSearchRoot = "";
	}

	if(liveSearchLast != searchvalue)
	{
		if(liveSearchReq && liveSearchReq.readyState < 4)
		{
			liveSearchReq.abort();
		}
		if(searchvalue == "")
		{
			liveSearchHide(fieldid);
			return false;
		}
		if(window.XMLHttpRequest)
		{
			// branch for IE/Windows ActiveX version
		}
		else if(window.ActiveXObject)
		{
			liveSearchReq = new ActiveXObject("Microsoft.XMLHTTP");
		}
		// note: new function workaround to hand over a parameter to onreadystatechange-function
		//liveSearchReq.onreadystatechange = new Function('fx', 'liveSearchProcessReqChange("' + fieldid + '")');
		//liveSearchReq.open("GET", encodeURI(liveSearchRoot + "http://beta.skins.be/home/ajax.php?type=suggest&action=tags&value_one=") + urlencode_string(searchvalue), true);
		liveSearchLast = searchvalue;
		//liveSearchReq.send(null);
	}
}

//babe-search:
function liveSearchBabeSearch(fieldid)
{
	var searchvalue = document.getElementById(fieldid).value;

	if(typeof liveSearchRoot == "undefined")
	{
		liveSearchRoot = "";
	}

	if(liveSearchLast != searchvalue)
	{
		if(searchvalue == "")
		{
			liveSearchHide(fieldid);
			return false;
		}

		var output = getBabesFromArray(searchvalue);

		if(output)
		{
			liveSearchLast = searchvalue;
			var  res = document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSResult");
			res.style.display = "block";
			var  sh = document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSShadow");
			sh.innerHTML = output;
		}
		else{
			// nothing found in babe-array, start a tag search
			liveSearchTagSearch(fieldid);
		}
	}
}

function liveSearchProcessReqChange(fieldid)
{
	if(liveSearchReq.readyState == 4)
	{
		var  res = document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSResult");
		res.style.display = "block";
		var  sh = document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSShadow");
		sh.innerHTML = liveSearchReq.responseText;
	}
}

//search the babe-array:
function getBabesFromArray(searchvalue)
{
	var i,j;
	var results = 0;
	var result_array = new Array();
	var max_results = livesearch_settings['babe']['max_results'];
	var output = '';
	re = new RegExp("^" + searchvalue, "i");
	for(i = 0; i < babe_array.length; i++)
	{
		if(re.test(babe_array[i]))
		{
			result_array[results] = babe_array[i];
			results++;
		}
		else
		{
			var name_parts = babe_array[i].split(" ");
			for(j = 0; j < name_parts.length; j++)
			{
				if(re.test(name_parts[j]))
				{
					result_array[results] = babe_array[i];
					results++;
					break;
				}
			}
		}
		if(results == max_results)
		{
			break;
		}
	}

	if(results > 0)
	{
		output = '<ul class="LSRes">';
		for(i = 0; i < result_array.length; i++)
		{
			output = output + '<li class="LSRow" onmouseover="liveSearchHover(this);" onclick="babeSearchSubmit(\'babe\');"><a href="javascript:;">' + result_array[i] + '</a></li>';
		}
		output = output + '</ul>';

		return output;
	}
	else
	{
		return false;
	}
}

function tagSearchSubmit(fieldid)
{
	// get new value to put into field:
	if(document.getElementById("LSHighlight"))
	{
		var intofield = document.getElementById("LSHighlight").firstChild.firstChild.data;
	}

	// get value which is already in field
	var searchvalue = document.getElementById(fieldid).value;

	// strip last comma from value in field
	if(searchvalue.indexOf(',') > 0)
	{
		searchvalue = searchvalue.substr(0, searchvalue.lastIndexOf(','));
		searchvalue = trim(searchvalue);
	}
	else
	{
		searchvalue = '';
	}

	if(intofield)
	{
		if(searchvalue)
		{
			document.getElementById(fieldid).value = searchvalue + ', ' + intofield;
		}
		else
		{
			document.getElementById(fieldid).value = intofield;
		}
		closeResults(fieldid);
		document.getElementById(fieldid).focus();

		//opera-workaround to unselect text
		var temptext = document.getElementById(fieldid).value;
		document.getElementById(fieldid).value = "";
		document.getElementById(fieldid).value = temptext;

		liveSearchLast = '';
		return false;
	}
	else
	{
		return true;
	}

}

//put a babes-name into searchfield:
function babeSearchSubmit(fieldid)
{
	if(document.getElementById("LSHighlight"))
	{
		var intofield = document.getElementById("LSHighlight").firstChild.firstChild.data;
	}
	if(intofield)
	{
		document.getElementById(fieldid).value = intofield;
		closeResults(fieldid);
		document.getElementById(fieldid).focus();

		//opera-workaround to unselect text
		var temptext = document.getElementById(fieldid).value;
		document.getElementById(fieldid).value = "";
		document.getElementById(fieldid).value = temptext;

		liveSearchLast = intofield;

		var the_form = document.getElementById(fieldid).parentNode.parentNode;
		var the_form_name = the_form.getAttribute('name');
	//	document.forms[the_form_name].submit();

		return true;
	}
	else
	{
		return true;
	}
}

function liveSearchHover(el)
{
	highlight = document.getElementById("LSHighlight");
	if(highlight)
	{
		highlight.removeAttribute("id");
	}
	el.setAttribute("id","LSHighlight");
}

function liveSearchClicked(el)
{
	var cur_form = el.parentNode.parentNode.parentNode.parentNode;
	var inputs = cur_form.getElementsByTagName("input");
	var fieldid = inputs[1].getAttribute("id");


	highlight = document.getElementById("LSHighlight");
	if(highlight)
	{
		highlight.removeAttribute("id");
	}
	el.setAttribute("id","LSHighlight");

	if(fieldid == "tag")
	{
		return tagSearchSubmit(fieldid);
	}
	else if(fieldid == "babe")
	{
		return babeSearchSubmit(fieldid);
	}
}

function closeResults(fieldid)
{
	highlight = document.getElementById("LSHighlight");
	if(highlight)
	{
		highlight.removeAttribute("id");
	}
	document.getElementById(livesearch_settings[fieldid]['css_prefix'] + "LSResult").style.display = "none";
}

function trim(str)
{
	return str.replace(/^\s+|\s+$/g, '')
}

// this function encodes every char of a string into its hexvalue with a prefixed %
// you can decode this with the "rawurldecode"-function in php
function urlencode_string(estring)
{
	var hex = '0123456789ABCDEF';
	var encString = '';
	var e_char = '';
	var e_len = estring.length;

    for(i = 0; i < e_len; i++)
    {
        e_char = parseInt(estring.charCodeAt(i));
        encString += '%' + hex.charAt((e_char >> 4) % 16 ) + hex.charAt(e_char % 16);
    }

    return encString;
}

/* ---------- Babe-Array ---------- */
var babe_array = new Array(
	"Aaliyah",
	"Abigail Clancy",
	"Adele Silva",
	"Adriana Lima",
	"Adriana Sklenarikova",
	"Aishwarya Rai",
	"Aisleyne Horgan-Wallace",
	"Alana Curry",
	"Alessandra Ambrosio",
	"Alessia Marcuzzi",
	"Alex Elliot",
	"Alexa Vega",
	"Alexandra Kamp",
	"Alexis Bledel",
	"Ali Landry",
	"Ali Larter",
	"Alicia Keys",
	"Alicia Silverstone",
	"Alicia Witt",
	"Alison King",
	"Alizee",
	"Allison Mack",
	"Almudena Fernandez",
	"Alyson Hannigan",
	"Alyssa Milano",
	"Amanda Bynes",
	"Amanda Detmer",
	"Amanda Holden",
	"Amanda Marcum",
	"Amanda Peet",
	"Amanda Tapping",
	"Amber Arbucci",
	"Amber Brkich",
	"Amber Smith",
	"Amber Tamblyn",
	"Amber Valletta",
	"Amy Acker",
	"Amy Adams",
	"Amy Lee",
	"Amy Nuttall",
	"Amy Smart",
	"Amy Weber",
	"Ana Beatriz Barros",
	"Ana Claudia Michels",
	"Ana Hickman",
	"Ana Sofia Henao",
	"Anastacia",
	"Andrea Corr",
	"Angel Faith",
	"Angela Lindvall",
	"Angela Martin",
	"Angela Taylor",
	"Angelica Bridges",
	"Angelina Jolie",
	"Angie Everhart",
	"Anine Bing",
	"Anna Falchi",
	"Anna Faris",
	"Anna Friel",
	"Anna Kournikova",
	"Anna Mouglalis",
	"Anna Paquin",
	"Annalise Braakensiek",
	"Anne Hathaway",
	"Anne Heche",
	"Anta Fall",
	"Aria Giovanni",
	"Arielle Kebbel",
	"Ashanti",
	"Ashlee Simpson",
	"Ashley Hartman",
	"Ashley Judd",
	"Ashley Scott",
	"Ashley Tisdale",
	"Asia Argento",
	"Atomic Kitten",
	"Aurelie Claudel",
	"Aurora Robles",
	"Avril Lavigne",
	"Bai Ling",
	"Belinda Chapple",
	"Beverley Mitchell",
	"Beyonce Knowles",
	"Bianca Gascoigne",
	"Bijou Phillips",
	"Billie Piper",
	"Bobbi  Billard",
	"Brande Roderick",
	"Briana Banks",
	"Bridget Fonda",
	"Bridget Moynahan",
	"Brie Larson",
	"Britney Spears",
	"Brittany Daniel",
	"Brittany Murphy",
	"Brittany Snow",
	"Brooke Burke",
	"Brooke Burns",
	"Brooke Richards",
	"Bryce Dallas Howard",
	"Busy Phillips",
	"Calista Flockhart",
	"Cameron Diaz",
	"Camille Natta",
	"Candice Michelle",
	"Caprice Bourret",
	"Carmella Decesare",
	"Carmen Electra",
	"Carolina Di Nezio",
	"Carre Otis",
	"Carrie-Anne Moss",
	"Cassie Lane",
	"Cat Deeley",
	"Cate Blanchett",
	"Caterina Murino",
	"Catherine Bell",
	"Catherine Zeta Jones",
	"Chandra West",
	"Charisma Carpenter",
	"Charlie O Neale",
	"Charlize Theron",
	"Charlotte Church",
	"Charlotte Ross",
	"China Chow",
	"Chloe Jones",
	"Christina Aguilera",
	"Christina Applegate",
	"Christina Lindley",
	"Christina Milian",
	"Christina Ricci",
	"Christy Turlington",
	"Chyler Leigh",
	"Cindy Crawford",
	"Cindy Margolis",
	"Claire Danes",
	"Claire Forlani",
	"Claudia Schiffer",
	"Colleen Fitzpatrick",
	"Collien Fernandes",
	"Constance Marie",
	"Courteney Cox",
	"Courtney Love",
	"Daisy Fuentes",
	"Dani Behr",
	"Daniela Pestova",
	"Danielle Lloyd",
	"Dannii Minogue",
	"Debra Messing",
	"Delta Goodrem",
	"Demi Moore",
	"Denise Richards",
	"Devon Aoki",
	"Diane Kruger",
	"Diane Lane",
	"Diane Neal",
	"Dina Meyer",
	"Dita von Teese",
	"Dominique Swain",
	"Donna Air",
	"Donna Feldman",
	"Doreen Jacobi",
	"Doutzen Kroes",
	"Drew Barrymore",
	"Elena Anaya",
	"Elisabeth Harnois",
	"Elisabeth Shue",
	"Elisabetta Canalis",
	"Elisha Cuthbert",
	"Eliza Dushku",
	"Elizabeth Berkley",
	"Elizabeth Hurley",
	"Elize du Toit",
	"Elle Macpherson",
	"Elsa Benitez",
	"Emilie De Ravin",
	"Emily Gleason",
	"Emily Procter",
	"Emily Scott",
	"Emma B",
	"Emma Bunton",
	"Emma Caulfield",
	"Emma Watson",
	"Emmanuelle Beart",
	"Emmy Rossum",
	"Erika Christensen",
	"Estefania Urdaneta",
	"Estella Warren",
	"Esther Canadas",
	"Esther Schweins",
	"Eva Herzigova",
	"Eva LaRue",
	"Eva Longoria",
	"Eva Mendes",
	"Eva Padberg",
	"Evan Rachel Wood",
	"Evangeline Lilly",
	"Fabiana Tambosi",
	"Faith Hill",
	"Famke Janssen",
	"Fernanda Motta",
	"Fiona Apple",
	"Franziska Van Almsick",
	"Gabriela Cubert",
	"Gabrielle Richens",
	"Gabrielle Union",
	"Gail Porter",
	"Gemma Atkinson",
	"Gena Lee Nolin",
	"Geri Halliwell",
	"Gessica Iachini",
	"Gillian Anderson",
	"Gina Gershon",
	"Giorgia Palmas",
	"Gisele Bundchen",
	"Grace Park",
	"Guinevere Vanseenus",
	"Gwen Stefani",
	"Gwyneth Paltrow",
	"Halle Berry",
	"Hayden Panettiere",
	"Heather Graham",
	"Heather Locklear",
	"Heather Pariso",
	"Heidi Klum",
	"Helena Christensen",
	"Hilary Duff",
	"Hillary Swank",
	"Holly Marie Combs",
	"Holly Valance",
	"Ilary Blasi",
	"Imogen Bailey",
	"Ines Sastre",
	"Isabeli Fontana",
	"Izabella Scorupco",
	"Jackie Gayda",
	"Jaime Pressly",
	"Jakki Degg",
	"Jamelia",
	"James King",
	"Jamie Lynn Spears",
	"Jana Ina",
	"Janet Jackson",
	"Jemimah Goosen",
	"Jenna Elfman",
	"Jenna Jameson",
	"Jennie Corner",
	"Jennie Garth",
	"Jennifer Aniston",
	"Jennifer Beals",
	"Jennifer Connelly",
	"Jennifer Ellison",
	"Jennifer Garner",
	"Jennifer Hawkins",
	"Jennifer Lamiraqui",
	"Jennifer Lopez",
	"Jennifer Love Hewitt",
	"Jennifer Morrison",
	"Jennifer O Dell",
	"Jennifer Sky",
	"Jennifer Walcott",
	"Jenny Frost",
	"Jenny Mccarthy",
	"Jeri Ryan",
	"Jessica Alba",
	"Jessica Barton",
	"Jessica Biel",
	"Jessica Jaymes",
	"Jessica Simpson",
	"Jewel",
	"Jill Hennessy",
	"Joana Rodriguez Viada",
	"Joanna Krupa",
	"Jojo",
	"Jolene Blalock",
	"Jordana Brewster",
	"Josie Maran",
	"Joss Stone",
	"Jules Asner",
	"Julia Roberts",
	"Julia Stiles",
	"Julianne Moore",
	"Julie Benz",
	"Kaley Cuoco",
	"Karen Elson",
	"Karen Ferrari",
	"Karima Adebibe",
	"Karolina Kurkova",
	"Kate Beckinsale",
	"Kate Bosworth",
	"Kate Groombridge",
	"Kate Hudson",
	"Kate Lawler",
	"Kate Mara",
	"Kate Moss",
	"Kate Winslet",
	"Katharine McPhee",
	"Katherine Heigl",
	"Kathleen Robertson",
	"Kathryn Morris",
	"Katie Downes",
	"Katie Holmes",
	"Katie Lohmann",
	"Katie Melua",
	"Katie Price (Jordan)",
	"Katie Richmond",
	"Katy Rose",
	"Kayleigh Pearson",
	"Keegan Connor Tracy",
	"Keeley Hazell",
	"Keira Knightley",
	"Kelly Brook",
	"Kelly Carlson",
	"Kelly Clarkson",
	"Kelly Hu",
	"Kelly Ripa",
	"Kerry Mcgregor",
	"Kiele Sanchez",
	"Kim Cattral",
	"Kim Smith",
	"Kimberley Davies",
	"Kirsten Dunst",
	"Kirsty Gallacher",
	"Kirsty Hume",
	"Krista Allen",
	"Kristanna Loken",
	"Kristen Bell",
	"Kristin Cavallari",
	"Kristin Davis",
	"Kristin Kreuk",
	"Kristy Swanson",
	"Kylie Bax",
	"Kylie Minogue",
	"Lacey Chabert",
	"Laetitia Casta",
	"Laila Rouass",
	"Lake Bell",
	"Laura Prepon",
	"Lauren Graham",
	"Lauren Pope",
	"Leah Remini",
	"Leann Rimes",
	"Leeann Tweeden",
	"Leelee Sobiesky",
	"Lena Gercke",
	"Leonor Varela",
	"Leslie Bibb",
	"Lil Kim",
	"Lily Allen",
	"Linda Cardellini",
	"Linda Evangelista",
	"Linda Park",
	"Lindsay Lohan",
	"Lisa Faulkner",
	"Lisa Gleave",
	"Lisa Kudrow",
	"Lisa Martinaglia",
	"Lisa Snowdon",
	"Liv Tyler",
	"Liz McClarnon",
	"Louise Glover",
	"Louise Nurding",
	"Luciana Salazar",
	"Lucie Silvas",
	"Lucy Clarkson",
	"Lucy Liu",
	"Lucy Pinder",
	"Luisa Corna",
	"Lujan Fernandez",
	"Madonna",
	"Maggie Grace",
	"Mandy Moore",
	"Manuela Arcuri",
	"Marcia Cross",
	"Maria Bello",
	"Maria Grazia Cucinotta",
	"Maria Menounos",
	"Maria Sharapova",
	"Mariah Carey",
	"Marisa Coughlin",
	"Marisa Miller",
	"Marisa Tomei",
	"Mariska Hargitay",
	"Marne Patterson",
	"May Andersen",
	"Mayra Veronica",
	"Meagan Good",
	"Meg Ryan",
	"Megan Fox",
	"Melanie Brown",
	"Melanie C",
	"Melinda Clarke",
	"Melissa George",
	"Melissa Joan Hart",
	"Mena Suvari",
	"Mia Maestro",
	"Michelle Branch",
	"Michelle Hunziker",
	"Michelle Marsh",
	"Michelle Rodriguez",
	"Michelle Trachtenberg",
	"Mila Kunis",
	"Milla Jovovich",
	"Mirjam Weichselbraun",
	"Mischa Barton",
	"Molly Sims",
	"Monica Bellucci",
	"Mya Harrison",
	"Myleene Klass",
	"Naomi Campbell",
	"Naomi Watts",
	"Natalia Cigliuti",
	"Natalia Vodianova",
	"Natalie Bassingthwaighte",
	"Natalie Denning",
	"Natalie Imbruglia",
	"Natalie Portman",
	"Natasha Bedingfield",
	"Natasha Henstridge",
	"Nathalie Kelley",
	"Navi Rawat",
	"Nell McAndrew",
	"Nelly Furtado",
	"Neve Campbell",
	"Nicci Juice",
	"Nicky Hilton",
	"Nicole Charles",
	"Nicole Hiltz",
	"Nicole Kidman",
	"Nicole Richie",
	"Nikki Cox",
	"Nikki Nova",
	"Nikki Sanderson",
	"Nikki Visser",
	"Noemie Lenoir",
	"Olivia Wilde",
	"Olsen Twins",
	"Orlaith McAllister",
	"Padma Lakshmi",
	"Paige Butcher",
	"Pamela Anderson",
	"Paris Hilton",
	"Patricia Ford",
	"Paulina Rubio",
	"Paz Vega",
	"Penelope Cruz",
	"Pennelope Jimenez",
	"Penny Lancaster",
	"Peta Wilson",
	"Petra Nemcova",
	"Pink (Alecia Moore)",
	"Poppy Montgomery",
	"Pussycat Dolls",
	"Rachael Leigh Cook",
	"Rachel Bilson",
	"Rachel Hunter",
	"Rachel McAdams",
	"Rachel Nichols",
	"Rachel Roberts",
	"Rachel Stevens",
	"Rachel Weisz",
	"Radha Mitchell",
	"Ramona Drews",
	"Rebecca Gayheart",
	"Rebecca Loos",
	"Rebecca Romijn",
	"Rebekah Teasdale",
	"Reese Witherspoon",
	"Rene Russo",
	"Renee Zellweger",
	"Rihanna",
	"Roberta Murgo",
	"Rosamund Pike",
	"Rosario Dawson",
	"Rose McGowan",
	"Roselyn Sanchez",
	"Roxanne Pallet",
	"Sabrina Ferilli",
	"Salma Hayek",
	"Samantha Cole",
	"Samantha Mumba",
	"Sandra Bullock",
	"Sarah Connor",
	"Sarah Jessica Parker",
	"Sarah Kozer",
	"Sarah Michelle Gellar",
	"Sarah Shahi",
	"Sasha Zyablitskay",
	"Scarlett Johansson",
	"Selma Blair",
	"Shakira",
	"Shania Twain",
	"Shannen Doherty",
	"Shannon Elizabeth",
	"Shannyn Sossamon",
	"Sharon Case",
	"Sharon Stone",
	"Shiri Appleby",
	"Shirley Manson",
	"Shu Qi",
	"Sienna Miller",
	"Silvie Meis",
	"Sky Lopez",
	"Sofia Vergara",
	"Sophia Bush",
	"Sophie Anderton",
	"Sophie Ellis Bextor",
	"Sophie Howard",
	"Stacey Dash",
	"Stacie Orrico",
	"Stacy Ferguson (Fergie)",
	"Stacy Keibler",
	"Stefania Orlando",
	"Stephanie Seymour",
	"Sugababes",
	"Summer Altice",
	"Sung Hi Lee",
	"Susan Ward",
	"Tammin Sursok",
	"Tara Conner",
	"Tara Reid",
	"Taryn Manning",
	"Tatu",
	"Tera Patrick",
	"Teresa De Klerk",
	"Teri Hatcher",
	"Thalia",
	"Tiffani Amber Thiessen",
	"Tiffany Mulheron",
	"Tiffany Selby",
	"Toni Braxton",
	"Tori Spelling",
	"Torrie Wilson",
	"Tricia Helfer",
	"Trish Stratus",
	"Tyra Banks",
	"Uma Thurman",
	"Unknown Babes",
	"Ursula Mayes",
	"Vanessa Lorenzo",
	"Vanessa Marcil",
	"Veronica Varekova",
	"Veronica Zemanova",
	"Victoria Beckham",
	"Victoria Pratt",
	"Victoria Silvstedt",
	"Vida Guerra",
	"Virginie Ledoyen",
	"Viviana Greco",
	"Whitney Houston",
	"Yamila Diaz",
	"Yasmine Bleeth",
	"Yvonne Catterfeld",
	"Zhang Ziyi"
);